//==== set Menu Buttons pin numbers:
    const boolean BT_Next = 22;     
    const boolean BT_Prev = 23;   
    const boolean BT_Down = 24;    
    const boolean BT_Up = 25;
//==== Green LED Pin
    int GreenLED = 36;
//==== set Menu Buttons Variable that will change
    int BT_Next_State = 0;      
    int BT_Prev_State = 0;       
    int BT_Down_State = 0;       
    int BT_Up_State = 0; 
    
    
//==== set Buttons pin numbers:
    const boolean Button_01 = 26;
    const boolean Button_02 = 27;
    const boolean Button_03 = 28;
    const boolean Button_04 = 29;
    const boolean Switch_01 = 30;
    const boolean Switch_02 = 31;
    const boolean Switch_03 = 32;
    const boolean Switch_04 = 33;
    const boolean Switch_05 = 34;
    const boolean Switch_06 = 35;
//==== set Buttons Variable that will change
    int Button_01_State = 0;      
    int Button_02_State = 0;       
    int Button_03_State = 0;       
    int Button_04_State = 0;
    int Switch_01_State = 0;
    int Switch_02_State = 0;
    int Switch_03_State = 0;
    int Switch_04_State = 0;
    int Switch_05_State = 0;
    int Switch_06_State = 0;
 
//==== Variable for Analog Input Value
    int Analog0 = 0;       
    int Analog1 = 0;       
    int Analog2 = 0;       
    int Analog3 = 0;
    int Analog4 = 0;
    int Analog5 = 0;
    int Analog6 = 0;
    int Analog7 = 0;
//==== PotCount
    int PotCount = 0;
//==== Size of Buffer for Analog value
    const int bufferSize = 128;
//==== Buffer for Analog text variable 
    char buffer0[bufferSize];
    char buffer1[bufferSize];
    char buffer2[bufferSize];
    char buffer3[bufferSize];
    char buffer4[bufferSize];
    char buffer5[bufferSize];
    char buffer6[bufferSize];
    char buffer7[bufferSize];
    char PotBuffer[bufferSize];
//         
    boolean Refresh = 1; 
//==== I/O Token
    boolean IOToken = 0;
//==== Serial Out Token
    boolean SerialOutToken = 0;
//==== Menu Token
    boolean MainMenuToken = 1;
//==== Token to know a change
    boolean MenuChangeToken = 1; 
//==== Menu selection counter
    int MenuSelect = 0;
    
// Page counter 
    int CountPage = 0;
    int PageView = 0;
// Scrolling menu
    int Scrolling = 0;




//==================== Start Setup ==========================
void setup(){
// initialize the buttons pin as an input:
    pinMode(BT_Next, INPUT);  
    pinMode(BT_Prev, INPUT);
    pinMode(BT_Down, INPUT);
    pinMode(BT_Up, INPUT);
    pinMode(GreenLED, OUTPUT);
    //==== Debug Serial Port
    Serial.begin(9600);  
    //==== uOLED Serial Port
    Serial1.begin(115200);
      //==== Initialize uOLED-128
      OLED_Init();
      OLED_Clear();
      
}
//=================== End Setup ==========================

//===================== Start Main Loop ==================================
void loop(){
  
    //==== Read the Menu Buttons
    MenuButtonsRead();
    //==== Draw MainMenu
    MainMenu();
    //==== Scroll the Menu
    MenuScrolling();
    //==== I/O Page
    IOPage();
    //==== Start-Stop Serial Out
    SerialOut();
    //==== Serial LED display
    SerialLED();
    //==== Update ScrollPot value
    ScrollPot();
    
loop();
}
//===================== END Main Loop ==================================

//===================== START Main Menu =====================
void MainMenu(){
if (MainMenuToken == 1){     
      //==== Update if token is 1
      if (MenuChangeToken == 1){
        //==== Witch menu is sellected
        switch(MenuSelect){
          case 0:
              OLED_DrawRectangle(2, 22, 110, 11, 2, GetRGB(153, 0, 0)); //16pixel between each
              OLED_DrawRectangle(2, 38, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 54, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 70, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 86, 110, 11, 2, 0x0000);
            break;
          case 1:
              OLED_DrawRectangle(2, 22, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 38, 110, 11, 2, GetRGB(153, 0, 0));
              OLED_DrawRectangle(2, 54, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 70, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 86, 110, 11, 2, 0x0000);
            break;
          case 2:
              OLED_DrawRectangle(2, 22, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 38, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 54, 110, 11, 2, GetRGB(153, 0, 0));
              OLED_DrawRectangle(2, 70, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 86, 110, 11, 2, 0x0000);
            break;
          case 3:
              OLED_DrawRectangle(2, 22, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 38, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 54, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 70, 110, 11, 2, GetRGB(153, 0, 0));
              OLED_DrawRectangle(2, 86, 110, 11, 2, 0x0000);
            break;
          case 4:
              OLED_DrawRectangle(2, 22, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 38, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 54, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 70, 110, 11, 2, 0x0000);
              OLED_DrawRectangle(2, 86, 110, 11, 2, GetRGB(153, 0, 0));
            break;
        }

          //==== Set text Transparent
          OLED_SetTextTrans(0);
          //==== Draw Menu
          OLED_DrawText(0, 15, 0, "DIY-Remote", 0xFFFF);
          OLED_DrawText(4, 0, 2, "Main Menu", 0xFFFF);
          OLED_DrawText(1, 3, 0, "Input/Output", 0xFFFF);
          OLED_DrawText(1, 5, 0, "Serial ON/OFF", 0xFFFF);
          OLED_DrawText(1, 7, 0, "LynxMotion", 0xFFFF);
          OLED_DrawText(1, 9, 0, "N/A", 0xFFFF);
          OLED_DrawText(1, 11, 0, "N/A", 0xFFFF);
          //==== Reset Token
          MenuChangeToken = 0;          
      }  
      if (BT_Next_State == 1 ){
        ButtonPress(1);    //==== Wait until the button is release
          //==== Menu Selection 1
          if (MenuSelect == 0 ){
            LoadingPage();
            if (IOToken == 0){
              IOToken = 1;
              MainMenuToken = 0;
              //delay(250);
            }
            else{
              IOToken = 0;
              //delay(250);
            }
          }
          //==== Menu Selection 2
          if (MenuSelect == 1 ){
            if (SerialOutToken == 0){
              SerialOutToken = 1;
              //delay(250);
            }
            else{
              SerialOutToken = 0;
             // delay(250);
            }
          }
          //==== Menu Selection 3
          if (MenuSelect == 2 ){
              OLED_Clear();
              OLED_Background(0xFFFF);
              OLED_ShowImage(0x00, 0x20, 0x80, 0x33, 0x10, 0x00, 0x00, 0x6F);
              delay(1000);
              OLED_Clear();
              OLED_Background(0x0000);
              MenuChangeToken = 1;
          }
          //==== Menu Selection 4
          if (MenuSelect == 3 ){
          }
      }
}
return;
}
//===================== END Main Menu =====================

//===================== Start Serial OUT ==================
void SerialOut(){
if (SerialOutToken == 1){  
  ButtonsRead();
  AnalogRead();
    if (SerialOutToken == 1){
       Serial.print("Digital ");
       Serial.print(Button_01_State, DEC);
       Serial.print(Button_02_State, DEC);
       Serial.print(Button_03_State, DEC);
       Serial.print(Button_04_State, DEC);
       Serial.print(Switch_01_State, DEC);
       Serial.print(Switch_02_State, DEC);
       Serial.print(Switch_03_State, DEC);
       Serial.print(Switch_04_State, DEC);
       Serial.print(Switch_05_State, DEC);
       Serial.print(Switch_06_State, DEC);
       Serial.print(" Analog  ");
       Serial.print(buffer0);
       Serial.print("-");
       Serial.print(buffer1);
       Serial.print("-");
       Serial.print(buffer2);
       Serial.print("-");
       Serial.println(buffer3);
    }
    else{
    }
}
return;
}

//===================== End Serial OUT ==================

//===================== START I/O Page ====================
void IOPage(){
  if (IOToken == 1){
    OLED_DrawText(0, 0, 0, PotBuffer, 0xFFFF); 
    MenuButtonsRead();
    ButtonsRead();
    AnalogRead();
      //==== Set text transparent
      OLED_SetTextTrans(1);
      //==== Draw Header
      OLED_DrawText(4, 0, 1, "I/O Page", GetRGB(0, 0, 255));
      OLED_DrawText(1, 2, 0, "Digital", GetRGB(194, 194, 194));
      OLED_DrawText(13, 2, 0, "Analog", GetRGB(194, 194, 194));
    //==== Goto Drawing I/O
    IODrawing();
    
  //==== Stay here or goto loop
  if (BT_Prev_State == 0){
      return;
      }
  else { 
    ButtonPress(2);
      IOToken = 0;
      MenuChangeToken = 1;
      MainMenuToken = 1;
      LoadingPage();
      return;
      }
 }    
}
//===================== END I/O Page =========================

//===================== Start Pages Transitions ===============
void LoadingPage(){
    //==== Clear the display
    OLED_Clear();
    //==== Set text Opaque
    OLED_SetTextTrans(1);
    //==== Write Loading Page
    OLED_DrawText(5, 53, 0, "LOADING PAGE", 0xFFFF);
    //==== Reset the Page counter
    CountPage = 0;
    //==== Goto Graph bar loading
    GraphLoading();
    //==== Clear the display
    OLED_Clear();
return;
} 
void GraphLoading(){
    //==== Do the square until 128
    if (CountPage < 128){
      OLED_DrawRectangle(0, 60, CountPage, 10, 0, GetRGB(153, 0, 0));
      //OLED_DrawCircle(64, 64, CountPage, 1, 0xFFFF);
      CountPage = (CountPage + 1);
      delay(2);
      GraphLoading();
    }  
    //==== Return to LoadingPage
    else{
      CountPage = 0;
      return; 
    } 
}
//===================== END Pages Transitions =====================  

//===================== Start Read Menu Button =========================
void MenuButtonsRead() {
    //==== Read Button
    BT_Next_State = digitalRead(BT_Next);      
    BT_Prev_State = digitalRead(BT_Prev);      
    BT_Down_State = digitalRead(BT_Down);      
    BT_Up_State = digitalRead(BT_Up);
    return;
}
//===================== End Read Menu Button ===========================

//===================== Start Read Button =========================
void ButtonsRead() {
    //==== Read Button
    Button_01_State = digitalRead(Button_01);
    Button_02_State = digitalRead(Button_02);
    Button_03_State = digitalRead(Button_03);
    Button_04_State = digitalRead(Button_04);    
    Switch_01_State = digitalRead(Switch_01);
    Switch_02_State = digitalRead(Switch_02);
    Switch_03_State = digitalRead(Switch_03);
    Switch_04_State = digitalRead(Switch_04);
    Switch_05_State = digitalRead(Switch_05);
    Switch_06_State = digitalRead(Switch_06);
    return;
}
//===================== End Read Button ===========================

//===================== Start Read Analog =========================
void AnalogRead() {
  //==== Analog Pin Association
    int AnalogPin0 = 0;      
    int AnalogPin1 = 1;      
    int AnalogPin2 = 2; 
    int AnalogPin3 = 3;
    int AnalogPin4 = 4;
    int AnalogPin5 = 5;
    int AnalogPin6 = 6;
    int AnalogPin7 = 7; 
  //==== Analog Read  
    Analog0 = analogRead(AnalogPin0);   
    Analog1 = analogRead(AnalogPin1);   
    Analog2 = analogRead(AnalogPin2);  
    Analog3 = analogRead(AnalogPin3);
    Analog4 = analogRead(AnalogPin4);
    Analog5 = analogRead(AnalogPin5);
    Analog6 = analogRead(AnalogPin6);
    Analog7 = analogRead(AnalogPin7);
  //==== Buffer the Analog value
    sprintf(buffer0, "%4.4d", Analog0);
    sprintf(buffer1, "%4.4d", Analog1);
    sprintf(buffer2, "%4.4d", Analog2);
    sprintf(buffer3, "%4.4d", Analog3);
    sprintf(buffer4, "%4.4d", Analog4);
    sprintf(buffer5, "%4.4d", Analog5);
    sprintf(buffer6, "%4.4d", Analog6);
    sprintf(buffer7, "%4.4d", Analog7);
    
    return;
}
//===================== End Read Analog ===========================

//===================== Start Menu Scrolling ======================   
void MenuScrolling(){      
      //==== Scrolling
      if (BT_Down_State == 1 ){  
          ButtonPress(4);      
          MenuChangeToken = 1;
          MenuSelect = (MenuSelect + 1);
          //delay(250);
      }
     if (BT_Up_State == 1 ){ 
          ButtonPress(3);        
          MenuChangeToken = 1;
          MenuSelect = (MenuSelect - 1);
          //delay(250);
      }
      //==== Reset MenuSelect if too low or too high
      if (MenuSelect > 4){
          MenuSelect = 0;
      }
      if (MenuSelect < 0){
          MenuSelect = 4;
      }
return;
}
//===================== END Menu Scrolling =========================

//===================== Start I/O page draw value ==================
void IODrawing(){
  
//==== Write Digital value
    OLED_DrawText(0, 4, 0, "BT #1", 0xFFFF);
      if (Button_01_State == 1){
        OLED_DrawRectangle(35, 32, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 32, 10, 6, 1, GetRGB(153, 0, 0));
      }
    OLED_DrawText(0, 5, 0, "BT #2", 0xFFFF);
      if (Button_02_State == 1){
        OLED_DrawRectangle(35, 40, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 40, 10, 6, 1, GetRGB(153, 0, 0));
      }
    OLED_DrawText(0, 6, 0, "BT #3", 0xFFFF);
      if (Button_03_State == 1){
        OLED_DrawRectangle(35, 48, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 48, 10, 6, 1, GetRGB(153, 0, 0));
      }    
    OLED_DrawText(0, 7, 0, "BT #4", 0xFFFF);
      if (Button_04_State == 1){
        OLED_DrawRectangle(35, 56, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 56, 10, 6, 1, GetRGB(153, 0, 0));
      }   
    OLED_DrawText(0, 9, 0, "SW #1", 0xFFFF);
      if (Switch_01_State == 1){
        OLED_DrawRectangle(35, 72, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 72, 10, 6, 1, GetRGB(153, 0, 0));
      }   
    OLED_DrawText(0, 10, 0, "SW #2", 0xFFFF);
      if (Switch_02_State == 1){
        OLED_DrawRectangle(35, 80, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 80, 10, 6, 1, GetRGB(153, 0, 0));
      }   
    OLED_DrawText(0, 11, 0, "SW #3", 0xFFFF);
      if (Switch_03_State == 1){
        OLED_DrawRectangle(35, 88, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 88, 10, 6, 1, GetRGB(153, 0, 0));
      }    
    OLED_DrawText(0, 12, 0, "SW #4", 0xFFFF);
      if (Switch_04_State == 1){
        OLED_DrawRectangle(35, 96, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 96, 10, 6, 1, GetRGB(153, 0, 0));
      }   
    OLED_DrawText(0, 13, 0, "SW #5", 0xFFFF);
      if (Switch_05_State == 1){
        OLED_DrawRectangle(35, 104, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 104, 10, 6, 1, GetRGB(153, 0, 0));
      }   
    OLED_DrawText(0, 14, 0, "SW #6", 0xFFFF);
      if (Switch_06_State == 1){
        OLED_DrawRectangle(35, 112, 10, 6, 1, GetRGB(51, 255, 0));
      }
      else{
        OLED_DrawRectangle(35, 112, 10, 6, 1, GetRGB(153, 0, 0));
      }  
      
//==== Write Digital value
    OLED_DrawText(9, 4, 0, "PosX A", 0xFFFF);
    OLED_DrawText(17, 4, 0, buffer0, GetRGB(255, 255, 0));
    OLED_DrawText(9, 5, 0, "PosY A", 0xFFFF);
    OLED_DrawText(17, 5, 0, buffer1, GetRGB(255, 255, 0));
    
    OLED_DrawText(9, 7, 0, "PosX B", 0xFFFF);
    OLED_DrawText(17, 7, 0, buffer2, GetRGB(255, 255, 0));
    OLED_DrawText(9, 8, 0, "PosY B", 0xFFFF);
    OLED_DrawText(17, 8, 0, buffer3, GetRGB(255, 255, 0));
    
    OLED_DrawText(9, 10, 0, "Sld #1", 0xFFFF);
    OLED_DrawText(17, 10, 0, buffer4, GetRGB(255, 255, 0));
    
    OLED_DrawText(9, 11, 0, "Sld #2", 0xFFFF);
    OLED_DrawText(17, 11, 0, buffer5, GetRGB(255, 255, 0));
    
    OLED_DrawText(9, 13, 0, "Aux #1", 0xFFFF);
    OLED_DrawText(17, 13, 0, buffer6, GetRGB(255, 255, 0));
    
    OLED_DrawText(9, 14, 0, "Aux #2", 0xFFFF);
    OLED_DrawText(17, 14, 0, buffer7, GetRGB(255, 255, 0));
      
return;
}
//===================== End I/O page draw value ==================

//===================== Start Serial LED =========================
void SerialLED(){
  if (MainMenuToken == 1) {
      if (SerialOutToken == 1){
        OLED_DrawRectangle(120, 121, 5, 5, 2, GetRGB(51, 255, 0));      //== Top right
        OLED_SetTextTrans(1);
        OLED_DrawText(12, 15, 0, "Online ", 0xFFFF);
      }
      else{
        OLED_DrawRectangle(120, 121, 5, 5, 2, GetRGB(153, 0, 0));      //== Top right
        OLED_SetTextTrans(1);
        OLED_DrawText(12, 15, 0, "Offline", 0xFFFF);
      }
  }
return;
}
//===================== End Serial LED ===========================

//===================== Start Button Press =========================
void ButtonPress(int Button){
  MenuButtonsRead();   
    if (Button == 1){
      if (BT_Next_State == 1){
        ButtonPress(1);
      }
    }
    if (Button == 2){
      if (BT_Prev_State == 1){
        ButtonPress(2);
      }
    }
    if (Button == 3){
      if (BT_Up_State == 1){
        ButtonPress(3);
      }
    }
    if (Button == 4){
      if (BT_Down_State == 1){
        ButtonPress(4);
      }
    }
    
return;
}
//===================== End Button Press =========================

//==================== Start Analog Pot Scroll ====================
void ScrollPot(){
  AnalogRead();
    
    if (Analog4 < 102){
      PotCount = 1;
    }
    if (Analog4 > 102){
      PotCount = 2;
    }
    if (Analog4 > 204){
      PotCount = 3;
    }
    if (Analog4 > 306){
      PotCount = 4;
    }     
    if (Analog4 > 408){
      PotCount = 5;
    }  
    if (Analog4 > 510){
      PotCount = 6;
    }  
    if (Analog4 > 612){
      PotCount = 7;
    }  
    if (Analog4 > 714){
      PotCount = 8;
    }  
    if (Analog4 > 816){
      PotCount = 9;
    }  
    if (Analog4 > 918){
      PotCount = 10;
    }  
  sprintf(PotBuffer, "%2.2d", PotCount);    
return;
}
//==================== End Analog Pot Scroll ====================

